#ifndef PILEH
#define PILEH
/*	Copyright (C) 1992 Free Software Foundation, Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this software; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */


/*  t. lord	Mon Apr  6 20:44:35 1992	*/

#include "global.h"

typedef struct ut_sPile *ut_Pile;

struct ut_sPile
{
  int used;
  int alloced;
  int size;
  void *data;
};

#ifdef __STDC__
extern ut_Pile ut_pile (int size, int alloc);
extern void *ut_pile_read (ut_Pile);
extern void *ut_pile_reserve (ut_Pile, int size);
extern void ut_pile_unreserve (ut_Pile, int size);
extern void ut_pile_clear (ut_Pile);
extern void ut_free_pile (ut_Pile);
#else
extern ut_Pile ut_pile ();
extern void *ut_pile_read ();
extern void *ut_pile_reserve ();
extern void ut_pile_unreserve ();
extern void ut_pile_clear ();
extern void ut_free_pile ();
#endif 
/*
 * for vals:
 *
 * typedef ut_Pile xx_FooPile;
 * #define xx_foopile()  ut_pile( sizeof (xx_Foo), 10 )
 * #define xx_foopile_add(P,L) ((void)\
 * 				   (*(xx_Foo*)ut_pile_reserve((P),1)\
 * 				    = (L)))
 * #define xx_foopile_clear ut_pile_clear
 * #define xx_free_foopile ut_free_pile
 * #define xx_foopile_size(P) ((P)->used)
 * #define xx_foopile_reserve(P,N)  (xx_Foo*)ut_pile_reserve((P),(N))
 * #define xx_foopile_read(P) ((xx_Foo*)(P)->data)
 */

/*
 * for structs passed as pointers
 *
 * typedef ut_Pile xx_BlitFixPile;
 * #define xx_blitfixpile()  ut_pile( sizeof (struct xx_sBlitFix), 10 )
 * #define xx_blitfixpile_add(P,L) ((void)\
 * 				   (*(xx_BlitFix)ut_pile_reserve((P),1)\
 * 				    = *(L)))
 * #define xx_blitfixpile_clear ut_pile_clear
 * #define xx_free_blitfixpile ut_free_pile
 * #define xx_blitfixpile_size(P) ((P)->used)
 * #define xx_blitfixpile_read(P) ((xx_BlitFix)(P)->data)
 * #define xx_blitfixpile_reserve(P,N)  (xx_BlitFix)ut_pile_reserve((P),(N))
 */
#endif
