#ifndef REGIONH
#define REGIONH
/*	Copyright (C) 1992 Free Software Foundation, Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this software; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*  t. lord	Tue Feb 11 02:04:44 1992	*/

#include "ir.h"
#include "rtree.h"

typedef xx_Rtree xx_Region;

#ifdef __STDC__
typedef int (*xx_RegionIterator) (xx_IntRectangle, void *);
extern xx_Region xx_region ();
extern void xx_free_region (xx_Region);
extern void xx_region_clear (xx_Region);
extern int xx_region_empty (xx_Region);
extern xx_Region xx_region_copy (xx_Region);
extern void xx_region_subtract_rectangle (xx_Region, xx_IntRectangle);
extern void xx_region_subtract_region (xx_Region, xx_Region);
extern void xx_region_adjoin_rectangle (xx_Region, xx_IntRectangle);
extern void xx_region_union (xx_Region, xx_Region);
extern void xx_region_adjoin_rectangle_loosely (xx_Region, xx_IntRectangle);
extern void xx_region_intersect_rectangle (xx_Region, xx_IntRectangle);
extern void xx_region_intersect_region (xx_Region, xx_Region);
extern void xx_region_iterate (xx_Region, xx_RegionIterator, void *);
extern int xx_region_equiv (xx_Region, xx_Region);
extern int xx_region_encloses (xx_Region, xx_Region);
extern int xx_region_intersects (xx_Region, xx_Region);
extern unsigned int xx_region_area (xx_Region);
extern void xx_region_complement (xx_Region, xx_IntRectangle);
#else

typedef int (*xx_RegionIterator) ();
extern xx_Region xx_region ();
extern void xx_free_region ();
extern void xx_region_clear ();
extern int xx_region_empty ();
extern xx_Region xx_region_copy ();
extern void xx_region_subtract_rectangle ();
extern void xx_region_subtract_region ();
extern void xx_region_adjoin_rectangle ();
extern void xx_region_union ();
extern void xx_region_adjoin_rectangle_loosely ();
extern void xx_region_intersect_rectangle ();
extern void xx_region_intersect_region ();
extern void xx_region_iterate ();
extern int xx_region_equiv ();
extern int xx_region_encloses ();
extern int xx_region_intersects ();
extern unsigned int xx_region_area ();
extern void xx_region_complement ();
#endif
#define xx_region_translate xx_rtree_translate
#ifdef PRETTY_PRINT_DECLS
extern void xx_pp_region (ut_PPstate, xx_Region);
extern void xx_pp_region_name (xx_Region, FILE *);
#endif
#endif

#ifdef PRETTY_PRINT
void
xx_pp_region_name (r, stream)
     xx_Region r;
     FILE *stream;
{
  fprintf (stream, "(xx_Region %x)", r);
}

int
xx_pp_region_rect (leaf, rect, vstate)
     xx_RtreeLeaf leaf;
     xx_IntRectangle rect;
     void *vstate;
{
  ut_PPstate state = (ut_PPstate) vstate;
  char *indent = ut_indent (state->indentation);

  fputs (indent, state->stream);
  xx_pp_intrectangle (rect, state->stream);
  fputc ('\n', state->stream);
  return 1;
}

void
xx_pp_region (state, r)
     ut_PPstate state;
     xx_Region r;
{
  char *indent = ut_indent (state->indentation);

  if (r)
    {
      fprintf (state->stream, "%s(xx_Region %x\n", indent, r);
      indent += 2;
      xx_region_iterate (r, xx_pp_region_rect, (void *) state);
    }
  else
    fprintf (state->stream, "%s(xx_Region %x)\n", indent, r);
}

#endif
